extern "C" {
    /* DSYEVX prototype */
    extern void dsyevx_( char* jobz, char* range, char* uplo, int* n, double* a,
	                int* lda, double* vl, double* vu, int* il, int* iu, double* abstol,
			int* m, double* w, double* z, int* ldz, double* work, int* lwork,
			int* iwork, int* ifail, int* info );
    /* DGEMM prototype */
    extern int dgemm_(char *transa, char *transb, int *m, int * n, int *k, 
			double *alpha, double *a, int *lda, double *b, 
			int *ldb, double *beta, double *c, int *ldc);
}

#include <stdio.h>
#include <stdlib.h>

int main() {

    double A[4*2] = {2,4,5,1,2,3,8,2};
    double B[2*3] = {-2.3,1.2,0,-1.2,0.2,-0.1};
    double C[4*3] = {0,0,0,0,0,0,0,0,0,0,0,0};

    int m = 4;
    int n = 3;
    int k = 2;
    double alpha = 1.0;
    double beta = 0.0;
    int ret = dgemm_("N", "N", &m, &n, &k, &alpha, A, &m, B, &k, &beta, C, &m);
    printf("ret %d from dgemm_\n");

    printf("A =[");
    for(int i=0; i<m; ++i) {
	for(int j=0; j<k; ++j) {
	    printf("%6.4f ", A[j*m + i]);
	}
	printf("\n");
    }
    printf("]\n");

    printf("B = [");
    for(int i=0; i<k; ++i) {
	for(int j=0; j<n; ++j) {
	    printf("%6.4f ", B[j*k + i]);
	}
	printf("\n");
    }
    printf("]\n");

    printf("C = [");
    for(int i=0; i<m; ++i) {
	for(int j=0;j<n; ++j) {
	    printf("%6.4f ", C[j*m+i]);
	}
	printf("\n");
    }
    printf("]\n");

    return 0;
}
