#include <tnt.h>
#include <jama_eig.h>
#include <iostream>

using namespace TNT;
using namespace JAMA;

const double gam = .1;
const int N = 25;

int main()
{
    Array2D< double > A(N,N);
    A = 0.0;

    double tmp;
    for (int i=0; i<N; ++i) {
	A[i][i] = 1.0;
	for(int j=i+1; j<N; ++j) {
	    tmp = (1.0*rand()/RAND_MAX) - (1.*rand()/RAND_MAX);
	    tmp = tmp*tmp;
	    A[i][j] = A[j][i] = exp(- gam*tmp);
	}
    }
    
    Eigenvalue<double> eigdecompA(A);

    Array2D<double> V(N,N);
    Array2D<double> D(N,N);

    eigdecompA.getV(V);
    eigdecompA.getD(D);

    cout << "V" << endl << V;
    cout << "D" << endl << D;

    return 0;
}
